"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const p5_analysis_1 = require("p5-analysis");
const utils_1 = require("../utils");
const sketchTypes = ['html', 'javascript'];
async function convert(sketchPath, options) {
    const sketch = await p5_analysis_1.Sketch.fromFile(sketchPath);
    const targetType = options.to || (sketch.sketchType === 'html' ? 'javascript' : 'html');
    if (!sketchTypes.includes(targetType)) {
        (0, utils_1.die)(`Invalid option --to ${options.to}; must be `);
    }
    if (sketch.sketchType === options.to) {
        console.log('Nothing to do');
        return;
    }
    try {
        await sketch.convert({ type: targetType });
    }
    catch (err) {
        (0, utils_1.die)(err.message);
    }
}
exports.default = convert;
