"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cyclicJsonBodyMiddleware = exports.parseCyclicJson = void 0;
const express_1 = __importDefault(require("express"));
const hasOwnProperty = Object.prototype.hasOwnProperty;
const scopeKey = '$__p5_server:circular';
const defKey = '$__p5_server:def';
const refKey = '$__p5_server:ref';
function parseCyclicJson(json) {
    const value = JSON.parse(json);
    if (!(typeof value === 'object' && hasOwnProperty.call(value, scopeKey)))
        return value;
    const defs = [];
    return resolve(value[scopeKey]);
    function resolve(value) {
        if (value && typeof value === 'object') {
            if (hasOwnProperty.call(value, defKey)) {
                value = value[defKey];
                defs.push(value);
            }
            else if (hasOwnProperty.call(value, refKey)) {
                return defs[value[refKey]];
            }
            for (const key in value) {
                value[key] = resolve(value[key]);
            }
        }
        else if (Array.isArray(value)) {
            for (const i in value) {
                value[i] = resolve(value[i]);
            }
        }
        return value;
    }
}
exports.parseCyclicJson = parseCyclicJson;
const textware = express_1.default.text({ type: 'application/json' });
function cyclicJsonBodyMiddleware() {
    return (req, _res, next) => textware(req, _res, () => {
        req.body = parseCyclicJson(req.body);
        next();
    });
}
exports.cyclicJsonBodyMiddleware = cyclicJsonBodyMiddleware;
